package edu.jt_kb.cs4308.compiler.models;

public enum Token {
    // Generic values setup from the example table used on the assignment description. Need to add more/setup more later.
    IDENT(0),ASS_OP(1),SUB_OP(2),DIV_OP(3),INT_LITERAL(4),SEMICOLON(5);

    public final int value; /* represents which Token you are referencing. */

    /**
     * Constructor for the ENUM to represent the value of each Token.
     *
     * @precondition: none
     * @postcondition: A token is created.
     *
     * @param value - the integer value for the token.
     */
    Token(int value) {
        this.value = value;
    }

    /**
     * Compares two tokens and returns whether they are the same value or not.
     *
     * @param other - the other token being compared.
     * @return if the values are the same,  true
     *         else,                        false
     */
    public boolean equals(Token other) {
        return this.value == other.value;
    }
}
